<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DTO\Response\Error;

class Coz01100CustoPlanejadoRealizado extends \Zeedhi\Framework\Controller\Report {

	protected $crudService;
	protected $util;
	protected $dataSourceManager;
	protected $novoCodigo;
	protected $entityManager;
	protected $birtStrategy;

	public function __construct(ReportService $reportService, $crudService, $util, $novoCodigo, $entityManager, $birtStrategy) {
		$this->crudService    	= $crudService;
		$this->util             = $util;
		$this->novoCodigo    	= $novoCodigo;
		$this->entityManager    = $entityManager;
		$this->birtStrategy     = $birtStrategy;
		
		parent::__construct($reportService);
    }
	
	protected $reportMapping = array (
      'cus01100' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01101' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01102' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01103' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01104' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01105' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01106' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01107' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01108' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01109' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'ORDENA'        => 'P_ORDENA',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01110' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'NRORG'         => 'P_NRORG'
            )
        ),
        'cus01111' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL'     => 'P_DTINI',
                'DTFINAL'       => 'P_DTFIN',
                'CDCENTRAL'     => 'P_CDCENTRAL',
                'NRLISTA'       => 'P_NRLISTA',
                'CDTIPOCUSTOREA'=> 'P_NRTIPOCUSTOREAL',
                'CDTIPOCUSTOPLA'=> 'P_NRTIPOCUSTOPLAN',
                'DIFQUANT'      => 'P_DIFERENCA',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'NRORG'         => 'P_NRORG'
            )
        )
    );
	
	public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
	    try{
	        $row = $request->getRow();
	        $filiserv = [];
    	    if(empty($row['NMSERVFILI'])){
    	    	$filiserv = $this->filtraServicos($row);
    	    }else{
    	    	foreach($row['NMSERVFILI'] as $filialservico){
	    	    	array_push($filiserv,$filialservico);
    	    	}
    	    }
    	    $row['NMSERVFILI'] = $filiserv;
    	    $row['NRLISTA'] = $this->gerarListaServ($row['NMSERVFILI'], $row['NRORG']);
    	    
    	    $nrListaConsplan = $this->gerarListaServ($row['NMSERVFILI'], $row['NRORG']);
    	    $row['NRCONSPLAN'] = $this->gerarNrConsplan($nrListaConsplan, $row);
    	   $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
	    }catch(\Exception $e){
	        $response->setError(new Error($e->getMessage(), 500));
	    }
	}
	
	private function filtraServicos($row){
		 $conditions = [
			 	array(
                    "columnName" => "NRORG",
                    "operator"   => '=',
                    "value"      =>  $this->crudService->getEnvironment()->getNrOrg()
                ),
                array(
                    "columnName" => 'CDCENTRAL',
                    "operator"   => '=',
                    "value"      => $row['CDCENTRAL']
                ),
                array(
                    "columnName" => 'CDGRUPFILI',
                    "operator"   => '=',
                    "value"      => $row['CDGRUPFILI']  === '' ? 'T' : $row['CDGRUPFILI']
                ),
                array(
                    "columnName" => 'CDGRUPSERV',
                    "operator"   => '=',
                    "value"      => $row['NMGRUPSERV'] === '' || sizeof($row['NMGRUPSERV']) == 0 ? 'T' : join('_',$row['NMGRUPSERV'])   
                ),
                array(
                    "columnName" => 'CDFILIAGREGA',
                    "operator"   => '=',
                    "value"      => $row['NMFILIAL'] === '' || sizeof($row['NMFILIAL']) == 0 ? 'T' : join('_',$row['NMFILIAL'])
                ),
                
            ];
         $dataset = $this->crudService->getFilteredDataSet("servico_por_filiais", $conditions);       
 		 $servicos = $dataset->getRows();
 		 
 		 $filiserv = [];
 		 foreach ($servicos as $servico) {
 		 	array_push($filiserv,$servico['FILISERV']);
 		 }
 		 
 		 return $filiserv;
	}
	
	private function gerarListaServ($servicos, $nrorg) {
     try {          
        	$nrlista = $this->novoCodigo->getCodeByTableName('LISTA', $nrorg);
        	$sql = "INSERT INTO LISTA (NRLISTA, CDLISTA)
        	                    VALUES (:NRLISTA, :CDLISTA)";
            // var_dump($servicos);die;
        	foreach ($servicos as $servico) {
                $stmt = $this->entityManager->getConnection()->prepare($sql);
                $stmt->execute(
                    array(
                        "NRLISTA" => $nrlista,
                        "CDLISTA" => $servico
                    )
                );
            }
            return $nrlista;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
	private function gerarNrConsplan($nrlista, $row) {
		try {
			$procedure = new StoredProcedure($this->entityManager->getConnection(), 'CONSPLAN_GERAL');
            $procedure->addParam(new Param('NRLISTA', Param::PARAM_INPUT, $nrlista, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('DTINICIAL', Param::PARAM_INPUT, $row['DTINICIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('DTFINAL', Param::PARAM_INPUT, $row['DTFINAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('IDPRODUTOS', Param::PARAM_INPUT, 'CFP', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('IDSEPPRATO', Param::PARAM_INPUT, 'P', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('PEACRESCIMO', Param::PARAM_INPUT, 0, Param::PARAM_TYPE_INT));
            $procedure->addParam(new Param('IDARREDOND', Param::PARAM_INPUT, 'N', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('CDPRODUTOINI', Param::PARAM_INPUT, '0', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('CDPRODUTOFIN', Param::PARAM_INPUT, 'Z', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('CDOPERADOR', Param::PARAM_INPUT, $this->crudService->getEnvironment()->getCdOperador(), Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('NRCONSPLANTH', Param::PARAM_INPUT, 'GERANOVCOD', Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('NRCONSPLAN', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 10));
            
            return $procedure->execute()['NRCONSPLAN'];
		} catch (\Exception $e) {
			throw $e;
    	}
	}
	
	public function excluirParametros(DTO\Request\Row $request, DTO\Response $response){
	    $row = $request->getRow();
	   if(isset($row["NRLISTA"])){
	        $this->util->deleteLista($row["NRLISTA"]);
    	    $connection = $this->entityManager->getConnection();
            $query="DELETE FROM CONSPLAN WHERE NRORG = :NRORG AND NRCONSPLAN = :NRCONSPLAN";
            $connection->executeQuery($query, array("NRORG" => $row['NRORG'], "NRCONSPLAN" => $row['NRCONSPLAN']));
	   }
	   
	}
}